//Daniel Collins
//4/16/2023

#include <LiquidCrystal.h>
LiquidCrystal lcd(9, 10, 8, 20, 21, 7);

int squareOut = 2;
int cap = 3;
int avg = 0;
int vmax;
int vmin;
int samples = 100;

// the setup function runs once when you press reset or power the board
void setup() {
  lcd.begin(16, 2); // Set up the number of columns and rows on the LCD.
  pinMode(squareOut, OUTPUT);
  pinMode(cap, INPUT);
  analogReadResolution(12);
  lcd.setCursor(0,0);
  lcd.print("average: ");
  lcd.setCursor(0,1);
  lcd.print("min:    max:");
}

// the loop function runs over and over again forever
void loop() {
  vmax = vmin = 0;
  noInterupts();
  for(int i=0; i<samples; i++){
    digitalWrite(squareOut, HIGH);
    delay(0.0000012);
    vmax+=analogRead(cap); //don't need delay, because max is right after HIGH
    digitalWrite(squareOut, LOW);
    delay(0.0000012);
    vmin+=analogRead(cap);
    delay(0.1); //noise levels are small, one sample is ok for average.
    avg+=analogRead(cap);
  }
  vmax=vmax/samples;
  vmin=vmin/samples;
  avg=avg/samples;
  lcd.setCursor(9,0);
  lcd.print(avg);
  lcd.print("    ");
  lcd.setCursor(4,1);
  lcd.print(vmin);
  lcd.print("    ");
  lcd.setCursor(8,1);
  lcd.print("max:");
  lcd.print(vmax);
  lcd.print("    ");
}
